Nx=1440;Nz=560;Ns=29;

%x0 = 101; xf = Nx-100;
x0 = 61+360; xf = Nx-60-360;
z0 = 110; zf = Nz-50;

pl = 1;

x=linspace(-Nx/8,Nx/8,Nx);

fax=8;   %Axes and Colorbar font size
fla=10;  %Title and labels font size


I=loadbin('~/rftomo/htomo_subduction/data/dvsub_wide','float');    dv=reshape(I,Nz,Nx);







if 0  % STARTING IMAGE
    

figfile = 'figs/Isub_gather_clip_1D';
titext = 'Source gathers for 1D background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 1'],'float');
    ii=reshape(I,Nz,Nx,[]); 
iig = [];
for ix = 1:29:Nx
 iig = [iig squeeze(ii(:,ix,:))];
end


    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,iig(z0:zf,x0:xf));axis equal tight; 
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   

end


if 0  % TRUE IMAGE
    

figfile = 'figs/Isub_gather_clip_true';
titext = 'Source gathers for true background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 5'],'float');
    ii=reshape(I,Nz,Nx,[]); 
iig = [];
for ix = 1:29:Nx
 iig = [iig squeeze(ii(:,ix,:))];
end
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,iig(z0:zf,x0:xf));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end




if 0  % 2X IMAGE
    

figfile = 'figs/Isub_gather_clip_2x';
titext = 'Source gathers for 2 times perturbation';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 9'],'float');
    ii=reshape(I,Nz,Nx,[]); 
iig = [];
for ix = 1:29:Nx
 iig = [iig squeeze(ii(:,ix,:))];
end
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,iig(z0:zf,x0:xf));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end




if 1  % INVERSION RESULTS
    




%for mm=[5 16 23 30]
for mm=[10 20 30 40 50]    
    %I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wide5FPR' num2str(mm)],'float');
    I=loadbin(['~/rftomo/htomo_subduction/data/ItestBPR' num2str(mm)],'float');
    
    ii=reshape(I,Nz,Nx,[]); ii=ii(:,:,1:29);
    iig = [];
    
    for ix = 1:29:Nx
        iig = [iig squeeze(ii(:,ix,:))];
    end
       
    figfile = 'figs/Isub_gather_test';
    titext = 'Source gathers for iteration ';
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,iig(z0:zf,x0:xf));axis equal tight; 
    cax=0.5*max(caxis);caxis([-cax cax]);
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext num2str(mm)],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200'); 
    
    
    figfile = 'figs/Isub_test';
    titext = 'Stacked image for iteration ';
    
    clf
    H=figure(2);
    imagesc(x(x0:xf),0:(zf-z0)/4,sum(ii(z0:zf,x0:xf,:),3));axis equal tight; 
    cax=0.5*max(caxis);caxis([-cax cax]);
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext num2str(mm)],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200'); 
    
    
    
    
    
end  
end


if 0  % INVERSION RESULTS
    

figfile = 'figs/Isub_5F_erf';
titext = '';


for mm=1:31
    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wide5FJ1' sprintf('%2d',mm)],'float');
    J(mm)=sum(I);
end  
    
    clf
    H=figure(2);clf;plot(0:30,J,'k','Linewidth',1.2)
    hold on;plot(0:30,ones(31,1)*-1.504e5,'--k','Linewidth',1.2)
    ylabel('Error function');xlabel('Iteration');
    title(titext,'fontsize',fla,'fontweight','bold')
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 3.5*pl 2.5])
    %set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end







