 module inversion
contains

!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!


subroutine project_basis(vadj,vupdate,Nx,Nz,Nrhs)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, nrhs, gx(45),gz(45)
  real           :: vadj(Nx*Nz*NRHS),vadjsum(Nz*Nx)
  real ::vupdate(Nx*Nz)
  real           :: vig(45),z(99),x(99),sumbase,base(99,99)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

  vadjsum = 0.
  do ixx = 1,28
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 
  do ixx = 30,NRHS-1
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 
 
 ixx=0
  do ix=520,920,50 !160,560,50
    do iz=150,350,50
        ixx=ixx+1
        gx(ixx)=ix
        gz(ixx)=iz
    enddo
  enddo

  do iz=1,99
    z(iz)=-pi/2 + (iz-1)*pi/98 
    x(iz)=z(iz);  
  enddo

  sumbase=0.
  do ix=1,99
  	do iz=1,99
 		 base(iz,ix)=cos(z(iz))**2*cos(x(ix))**2
		 sumbase=sumbase+base(iz,ix)
  	enddo
  enddo
 
  vig = 0.
  do ig=1,45
    do ix=1,99
  	do iz=1,99
     	    vig(ig)=vig(ig) + base(iz,ix)*vadjsum(gz(ig)+iz-49 + Nz*(gx(ig)+ix-49-1))/sumbase
       	enddo
    enddo
  enddo
 
  vupdate=0.
  do ig=1,45
    do ix=1,99
  	do iz=1,99                                     !! NOTE: STUCK A MINUS IN HERE. OPPOSITE OF GRAD DIRECTION
	
     	    vupdate(gz(ig)+iz-49 + Nz*(gx(ig)+ix-49-1)) = vupdate(gz(ig)+iz-49 + Nz*(gx(ig)+ix-49-1)) - vig(ig)*base(iz,ix)
       	enddo
    enddo
  enddo

  !!!vupdate=vadjsum

  if (myrank == 0 ) write(*,*) 'Projected onto basis'


end subroutine project_basis


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!

subroutine project_finebasis(vadj,vupdate,Nx,Nz,Nrhs)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, nrhs, gx(322),gz(322)
  real           :: vadj(Nx*Nz*NRHS),vadjsum(Nz*Nx)
  real ::vupdate(Nx*Nz)
  real           :: vig(322),z(47),x(47),sumbase,base(47,47)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

  vadjsum = 0.
  do ixx = 1,28
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 
  do ixx = 30,NRHS-1
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 
 
 ixx=0  
  do iz=122,446,24   
    do ix=456,984,24  !96,624,24
        ixx=ixx+1
        gx(ixx)=ix
        gz(ixx)=iz
    enddo
  enddo


  do iz=1,47
    z(iz)=-pi/2 + (iz-1)*pi/46 
    x(iz)=z(iz);  
  enddo


 
  sumbase=0.
  do ix=1,47
     do iz=1,47
 	base(iz,ix)=cos(z(iz))**2*cos(x(ix))**2
	sumbase=sumbase+base(iz,ix)
     enddo
  enddo
  
  
  vig = 0.
  do ig=1,322
    do ix=1,47
  	do iz=1,47
     	    !vig(ig)=vig(ig) + base(iz,ix)*vadjsum(gz(ig)+iz-49 + Nz*(gx(ig)+ix-49-1))/sumbase
	    vig(ig)=vig(ig) + base(iz,ix)*vadjsum(gz(ig)+iz-23 + Nz*(gx(ig)+ix-23-1))/sumbase
       	enddo
    enddo
  enddo
 
  vupdate=0.
  do ig=1,322
    do ix=1,47
  	do iz=1,47                                     !! NOTE: STUCK A MINUS IN HERE. OPPOSITE OF GRAD DIRECTION
	
     	    vupdate(gz(ig)+iz-23 + Nz*(gx(ig)+ix-23-1)) = vupdate(gz(ig)+iz-23 + Nz*(gx(ig)+ix-23-1)) - vig(ig)*base(iz,ix)
       	enddo
    enddo
  enddo

  !!!vupdate=vadjsum

  if (myrank == 0 ) write(*,*) 'Projected onto fine basis'


end subroutine project_finebasis




!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine project_finebasis2(vadj,vupdate,Nx,Nz,Nrhs)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, nrhs, gx(322),gz(322)
  real           :: vadj(Nx*Nz*NRHS),vadjsum(Nz*Nx)
  real           :: vupdate(Nx*Nz)
  real           :: vig(322),sumbase,base(72,72),t(72),t0(3),baseb(72)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

  vadjsum = 0.
  do ixx = 1,Nrhs
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 

 
 ixx=0  
  do iz=122,434,24   
    do ix=456,984,24  !96,624,24
        ixx=ixx+1
        gx(ixx)=ix
        gz(ixx)=iz
    enddo
  enddo


  t0=(/0, 1, 2/)
  do ix=1,72
    t(ix) = 3.*(ix-1)/(72.-1.)
  enddo
  do ix=1,24
    baseb(ix)    = 0.5*(t(ix)-0)**2
    baseb(ix+24) = -(t(ix+24)-1)**2 + (t(ix+24)-1) + 0.5
    baseb(ix+48) = 0.5*(1-(t(ix+48)-2))**2
  enddo
 
  sumbase=0.
  do ix=1,72
      do iz=1,72
 	base(iz,ix)=baseb(iz)*baseb(ix)
	sumbase=sumbase+base(iz,ix)
      enddo
  enddo
  
  
  vig = 0.
  do ig=1,322
    do ix=1,72
  	do iz=1,72
     	    !!vig(ig)=vig(ig) + base(iz,ix)*vadjsum(gz(ig)+iz-49 + Nz*(gx(ig)+ix-49-1))/sumbase
	    vig(ig)=vig(ig) + base(iz,ix)*vadjsum(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1))/sumbase
       	enddo
    enddo
  enddo
 
  vupdate=0.
  do ig=1,322
    do ix=1,72
  	do iz=1,72                                     !! NOTE: STUCK A MINUS IN HERE. OPPOSITE OF GRAD DIRECTION
	
     	    vupdate(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1)) = vupdate(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1)) - vig(ig)*base(iz,ix)
       	enddo
    enddo
  enddo

  !!!vupdate=vadjsum

  if (myrank == 0 ) write(*,*) 'Projected onto fine basis'


end subroutine project_finebasis2


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!

subroutine linesearch_mod(dv,vel,vupdate,step,Nx,Nz)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, iminJ2,ng
  real           ::  vupdate(Nx*Nz)
  real           :: dv(Nx*Nz), vel(Nx*Nz),tmpvel(Nz*Nx),step,maxv0,maxvu,dg(301),J2(301),minJ2
  
  
  !! dv is the true perturbation (just used here for scaling)
  !! vel is the current estimate of the perturbation
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

  tmpvel=0.
  do ix=110,610
    do iz=100,400
       tmpvel(iz + Nz*(ix-1)) = -vel(iz + Nz*(ix-1))+dv(iz + Nz*(ix-1))
    enddo
  enddo
  
  maxv0 = maxval(abs(tmpvel),Nx*Nz)
  maxvu = maxval(abs(vupdate),Nx*Nz)
  
  vupdate = maxv0/maxvu * vupdate

 

  do ig = 1,301
    !dg(ig) =(ig-150.)/50 
    dg(ig) =(ig+10.)/100.
  enddo

  J2=0.
  minJ2 = 1.e30
  do ig = 1,301
    do ix = 1,Nx*Nz
      J2(ig)=J2(ig)+(dv(ix)-dg(ig)*vupdate(ix))**2
    enddo
    if (J2(ig) .lt. minJ2) then
      minJ2 = J2(ig)
      iminJ2 = ig
    endif
  enddo 
  
  step = dg(iminJ2)
  


  !if (myrank == 0 ) write(*,*) 'Step size = ',step


end subroutine linesearch_mod


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!





subroutine smooth_model(vadj,vupdate,Nx,Nz,Nrhs)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, nrhs, nbase, nbase2
  real           :: vadj(Nx*Nz*NRHS),vadjsum(Nz*Nx)
  real  ::   vupdate(Nx*Nz)
  real           :: sumbase,base(Nx,Nx),x(Nx),z(Nx)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )


  nbase=50
  nbase2=nbase/2

  vadjsum = 0.
  do ixx = 1,Nrhs
    do iz = 1,Nz
        do ix = 1,Nx
           vadjsum(iz+Nz*(ix-1)) = vadjsum(iz+Nz*(ix-1)) + vadj(iz + Nz*(ix-1) + Nx*Nz*(ixx-1))
	enddo
    enddo
  enddo 

 


  do iz=1,nbase
    z(iz)=-pi/2 + (iz-1)*pi/(nbase-1)
    x(iz)=z(iz);  
  enddo

  sumbase=0.
  do ix=1,nbase+1
  	do iz=1,nbase+1
 		 base(iz,ix)=cos(z(iz))**2*cos(x(ix))**2
		 sumbase=sumbase+base(iz,ix)
  	enddo
  enddo
 
  vupdate=0.
  do ixx=nbase2+1,Nx-nbase2
    do izz=nbase2+1,Nz-nbase2
      do ix=-nbase2,nbase2
  	do iz=-nbase2,nbase2          !! NOTE: STUCK A MINUS IN HERE. OPPOSITE OF GRAD DIRECTION
     	    vupdate(izz+iz + Nz*(ixx+ix-1)) = vupdate(izz+iz + Nz*(ixx+ix-1)) &
	        - base(iz+nbase2+1,ix+nbase2+1)*vadjsum(izz + Nz*(ixx-1))/sumbase
       	enddo
      enddo
    enddo
  enddo
 

  if (myrank == 0 ) write(*,*) 'Smoothed velocity update'


end subroutine smooth_model
 
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!

subroutine vel2fine(vel,vel_base,Nx,Nz)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, gx(322),gz(322)
  real           :: vel(Nx*Nz),vel_base(322)
  real           :: sumbase,base(72,72),t(72),t0(3),baseb(72)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

 
 ixx=0  
  do iz=122,434,24   
    do ix=96,624,24 !456,984,24
        ixx=ixx+1
        gx(ixx)=ix
        gz(ixx)=iz
    enddo
  enddo


  t0=(/0, 1, 2/)
  do ix=1,72
    t(ix) = 3.*(ix-1)/(72.-1.)
  enddo
  do ix=1,24
    baseb(ix)    = 0.5*(t(ix)-0)**2
    baseb(ix+24) = -(t(ix+24)-1)**2 + (t(ix+24)-1) + 0.5
    baseb(ix+48) = 0.5*(1-(t(ix+48)-2))**2
  enddo
 
  sumbase=0.
  do ix=1,72
      do iz=1,72
 	base(iz,ix)=baseb(iz)*baseb(ix)
	sumbase=sumbase+base(iz,ix)
      enddo
  enddo
  
  
  vel_base = 0.
  do ig=1,322
    do ix=1,72
  	do iz=1,72
	    vel_base(ig)=vel_base(ig) + base(iz,ix)*vel(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1))/sumbase
       	enddo
    enddo
  enddo

  !!!vupdate=vadjsum

  if (myrank == 0 ) write(*,*) 'Projected velocity onto fine basis'


end subroutine vel2fine


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine fine2vel(vel_base,vel,Nx,Nz)

  use parser
  use fileio 

  implicit none
  
  include 'mpif.h'
  
  integer        :: ix,iz,nn,ixx,izz,ig,myrank,ierr,nprocs
  integer        :: nx, nz, gx(322),gz(322)
  real           :: vel(Nx*Nz),vel_base(322)
  real           :: sumbase,base(72,72),t(72),t0(3),baseb(72)
  real(kind=4),parameter   :: pi = 3.1415926E+0
  
  
  call MPI_Comm_rank( MPI_COMM_WORLD, myrank, ierr )

 
 ixx=0  
  do iz=122,434,24   
    do ix=96,624,24  !456,984,24 
        ixx=ixx+1
        gx(ixx)=ix
        gz(ixx)=iz
    enddo
  enddo


  t0=(/0, 1, 2/)
  do ix=1,72
    t(ix) = 3.*(ix-1)/(72.-1.)
  enddo
  do ix=1,24
    baseb(ix)    = 0.5*(t(ix)-0)**2
    baseb(ix+24) = -(t(ix+24)-1)**2 + (t(ix+24)-1) + 0.5
    baseb(ix+48) = 0.5*(1-(t(ix+48)-2))**2
  enddo
 
  sumbase=0.
  do ix=1,72
      do iz=1,72
 	base(iz,ix)=baseb(iz)*baseb(ix)
	sumbase=sumbase+base(iz,ix)
      enddo
  enddo
 
  vel=0.
  do ig=1,322
    do ix=1,72
  	do iz=1,72                                     
	
     	    vel(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1)) = vel(gz(ig)+iz-36 + Nz*(gx(ig)+ix-36-1)) + vel_base(ig)*base(iz,ix)
       	enddo
    enddo
  enddo

  !!!vupdate=vadjsum

  if (myrank == 0 ) write(*,*) 'Projected onto fine basis'


end subroutine fine2vel



end module inversion
